
#define	 F_CPU	16000000UL
#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <inttypes.h>
#include <avr/interrupt.h>
#include "ili9341.h"
#include "ili9341gfx.h"
#define	 POINTCOLOUR	PINK
#define SIZE	4

extern uint16_t vsetx,vsety,vactualx,vactualy,isetx,isety,iactualx,iactualy;
static FILE mydata = FDEV_SETUP_STREAM(ili9341_putchar_printf, NULL, _FDEV_SETUP_WRITE);
int pb6 = 1, casuta_goala = 6, cauta, valoare_random = 0;
uint8_t val = 0, pos = 0, i, j;
uint16_t vect_colours[12] = {WHITE, YELLOW, GREENYELLOW, OLIVE, ORANGE, GREEN, PINK, RED, MAGENTA, PURPLE, BLUE, BLACK};
int matrice[SIZE][SIZE];
static int val_int[11] = {2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048};
int max = 4, modified = 0;

void timer1_init(void)
{
	//mod normal, fara prescaler
    TCCR1A &= ~((1 << COM1A0) | (1 << COM1A1) |     // OC0A dezactivat
                (1 << COM1B0) | (1 << COM1B1) |     // OC0B dezactivat
                (1 << WGM10) | (1 << WGM11));       
    TCCR1B &= ~((1 << WGM12) | (1 << WGM13) | (1 << CS11) | (1 << CS12));
    TCCR1B |=   (1 << CS10);                       
}

void io_init(void)
{
	DDRD |= (1 << PD4);
    DDRD &= ~((1 << PD0) | (1 << PD6));
    PORTD |=  (1 << PD0) | (1 << PD6);
	
	DDRB &= ~((1 << PB2) | (1 << PB3));
    PORTB |=  (1 << PB2) | (1 << PB3);
	
	//DDRC &= ~(1 << PC2);
	//PORTC |=  (1 << PC2);
	
}



void draw_rect(uint8_t i, uint8_t j,uint8_t pos ){
	ili9341_setcursor(0,0);
	//box
	ili9341_fillrect(1 + i * 80,1 + j * 60 ,78,58,vect_colours[pos]);
	
	//number
	ili9341_setcursor(35 + 80 * i,25 + 60 * j);
	ili9341_settextcolour(BLACK,vect_colours[pos]);
	ili9341_settextsize(2);
	printf("%d", matrice[i][j]);
}

void random_box(){
	i = rand() % 4;
	j = rand() % 4;
	while (matrice[i][j] != 0){
		i = rand() % 4;
		j = rand() % 4;
	}
	pos = rand() % 2;
	matrice[i][j] = val_int[pos];
	draw_rect(i,j,pos);
}

void up(uint8_t i)
{
    uint8_t aux = 0, j = 0, u = 0; 
    for (j = 0; j < SIZE; j++)
    {
        aux = j;
        if (matrice[i][j] == 0)
        {
			//move the first box greater than 0
            while (matrice[i][++aux] == 0 && aux < SIZE);
            if (aux >= SIZE)     break;
            
            matrice[i][j] = matrice[i][aux];
            matrice[i][aux] = 0;
        }
        
        // add the same two values
        if (j > 0 && u == 0 && matrice[i][j - 1] == matrice[i][j])
        {
            u = 1;
			matrice[i][j - 1] = matrice[i][j - 1] * 2;
            matrice[i][j] = 0;
            j--;
        }
        else
            u = 0;
    }
}

void down(uint8_t i)
{
    int8_t aux = 0;
	uint8_t j, u = 0; 
    int jump = 0;
	if ((matrice[i][0] != matrice[i][1])
		&& (matrice[i][1] != matrice[i][2])
		&& (matrice[i][2] != matrice[i][3])){
		if((matrice[i][0] != 0)
			&& (matrice[i][1] != 0)
			&& (matrice[i][2] != 0)
			&& (matrice[i][3] != 0)){
			jump = 1;
		}
	}
	if (jump == 0){
		for (j = SIZE-1; j >= 0; j--)
		{
			aux = j;
			if (matrice[i][j] == 0)
			{
				while (matrice[i][aux] == 0 && aux >= 0){
					aux--;
				}
				if (aux <= -1)     break;
				
				matrice[i][j] = matrice[i][aux];
				matrice[i][aux] = 0;
			}
			
			if ( (j < SIZE-1) && u == 0 && matrice[i][j + 1] == matrice[i][j])
			{
				u = 1;
				matrice[i][j + 1] = matrice[i][j + 1] * 2;
				matrice[i][j] = 0;
				j++;
			}
			else
				u = 0;
		}
	}	
}

void left(uint8_t i)
{
    uint8_t aux = 0, j = 0, u = 0; 
    
    for (j = 0; j < SIZE; j++)
    {
        aux = j;
        if (matrice[j][i] == 0)
        {
            while (matrice[++aux][i] == 0 && aux < SIZE);
            if (aux >= SIZE)     break;
            
            matrice[j][i] = matrice[aux][i];
            matrice[aux][i] = 0;
        }
        
        if (j > 0 && u == 0 && matrice[j - 1][i] == matrice[j][i])
        {
            u = 1;
			matrice[j - 1][i] = matrice[j - 1][i] * 2;
            matrice[j][i] = 0;
            j--;
        }
        else
            u = 0;
    }
}

void right(uint8_t i)
{
    int8_t aux = 0;
	uint8_t j, u = 0; 
	int jump = 0;
	if (matrice[0][i] != matrice[1][i] 
		&& matrice[1][i] != matrice[2][i]
		&& matrice[2][i] != matrice[3][i]){
		if (matrice[0][i] != 0
			&& matrice[1][i] != 0
			&& matrice[2][i] != 0
			&& matrice[3][i] != 0){
				jump = 1;
		}
	}
	if (jump == 0) {
		for (j = SIZE-1; j >= 0; j--)
		{
			aux = j;
			if (matrice[j][i] == 0)
			{
				while (matrice[aux][i] == 0 && aux >= 0){
					aux--;
				}
				if (aux <= -1)     break;
				
				matrice[j][i] = matrice[aux][i];
				matrice[aux][i] = 0;
			}
			 
			if ( (j < SIZE-1) && u == 0 && matrice[j + 1][i] == matrice[j][i])
			{
				u = 1;
				matrice[j + 1][i] = matrice[j + 1][i] * 2;
				matrice[j][i] = 0;
				j++;
			}
			else
				u = 0;
		}
	}
}

void BUZZ(float period)
{
    float half_period;  // Initialize variables
 
    half_period = period/2; // Compute a half cycle period
 
	PORTD |= (1 << PD4);    				// Set the port pin
	for(j = 0; j < half_period; j++)
		_delay_ms(1);                         // Wait a half period     
        
	PORTD &= ~(1 << PD4);   				// Clear the port pin
	for(j = 0; j < half_period; j++)
		_delay_ms(1);                     // Wait a half period to clear the port pin
 
    return;
}

void draw_left_right(){
	for (j = 0; j < SIZE; j++) {
		for (i = 0; i < SIZE; i++)
		{
			if(matrice[i][j] != 0){
				pos = 0;
				while ((2 << pos) != matrice[i][j]){
					pos++;
				}
				draw_rect(i,j,pos);
				if(matrice[i][j] > max){
					max = matrice[i][j];
					modified = 1;
				}
			}
			else
				draw_rect(i,j,11);
		}	
	}
}

void draw_up_down() {
	for (i = 0; i < SIZE; i++){
		for (j = 0; j < SIZE; j++)
		{
			if(matrice[i][j] != 0){
				pos = 0;
				while ((2 << pos) != matrice[i][j]){
					pos++;
				}
				draw_rect(i,j,pos);
				if(matrice[i][j] > max){
					max = matrice[i][j];
					modified = 1;
				}
			}
			else
				draw_rect(i,j,11);
		}
	}
}

int main(void)
{
	io_init();
	timer1_init();
	memset(matrice, 0, SIZE * SIZE * sizeof(uint8_t));
	DDRC = 0xff;
	
	stdout = & mydata;
	ili9341_init();				//initial driver setup to drive ili9341
	ili9341_clear(BLACK);		//fill screen with black colour
	ili9341_setRotation(1);		//rotate screen
	_delay_ms(2);
	
	//menu start
	ili9341_setcursor(80,80);
	_delay_ms(2);
	ili9341_settextcolour(RED,BLACK);
	_delay_ms(2);
	ili9341_settextsize(3);
	_delay_ms(2);
	printf("Press up");
	ili9341_setcursor(80,110);
	printf("to play");
	while(1){
		if((PIND & (1 << PD0)) == 0 ){
			srand((unsigned)TCNT1);
			ili9341_clear(BLACK);//fill screen with black colour
			ili9341_setcursor(0,0);
			_delay_ms(2);
			ili9341_settextcolour(DARKGREY,DARKGREY);
			_delay_ms(2);
			//lines	
			ili9341_drawvline(0,0,240,BLUE);
			ili9341_drawvline(80,0,240,BLUE);
			ili9341_drawvline(160,0,240,BLUE);
			ili9341_drawvline(240,0,240,BLUE);
			ili9341_drawvline(319,0,240,BLUE);
			ili9341_drawhline(0,0,320,BLUE);
			ili9341_drawhline(0,60,320,BLUE);
			ili9341_drawhline(0,120,320,BLUE);
			ili9341_drawhline(0,180,320,BLUE);
			ili9341_drawhline(0,239,320,BLUE);
			random_box();
			
			while(1){
				//if button pressed then move and add a random box
				if((PIND & (1 << PD6)) == 0)
				{
					for ( i = 0; i < SIZE; i++) {
						right(i);
					}	
					draw_left_right(); //update the matrix
					random_box();		//add new radnom box
					if (modified == 1) {	//decide which sound to play
						BUZZ(50);
						modified = 0;
					} else {
						BUZZ(1);
					}
					_delay_ms(50);			
				} 
				else if((PINB & (1 << PB2)) == 0){
					for (i = 0; i < SIZE; i++) {
						down(i);
					}
					draw_up_down();
					random_box();
					if (modified == 1) {
						BUZZ(50);
						modified = 0;
					} else {
						BUZZ(1);
					}
					_delay_ms(50);
					
				}
				else if((PINB & (1 << PB3)) == 0){
					for ( i = 0; i < SIZE; i++) {
						left(i);
					}
					draw_left_right();
					random_box();	
					if (modified == 1) {
						BUZZ(75);
						modified = 0;
					} else {
						BUZZ(1);
					}
					_delay_ms(50);
					
				}
				else if((PIND & (1 << PD0)) == 0 ){
					for ( i = 0; i < SIZE; i++) {
						up(i);
					}
					draw_up_down();
					random_box();	
					if (modified == 1) {
						BUZZ(75);
						modified = 0;
					} else {
						BUZZ(1);
					}
					_delay_ms(50);
				}
				
			}
		}
	}
	return 0;
}